
CREATE DATABASE `mystore2`;

use mystore2;

CREATE TABLE `customers` (
  `ID` int(11) NOT NULL auto_increment,
  `NAME` varchar(50) NOT NULL default '',
  `FOR_NAME` varchar(50) NOT NULL default '',
  `ADDRESS` varchar(50) NOT NULL default '',
  `TOWN` varchar(50) NOT NULL default '',
  `COUNTRY` varchar(50) NOT NULL default '',
  `TOTAL_PRICE` double NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=InnoDB AUTO_INCREMENT=3;


INSERT INTO `customers` VALUES (1, 'Dupont', 'Jules', 'rue des lilas','Nimes','France', 3600.54);
INSERT INTO `customers` VALUES (2, 'Durand', 'Alfred', 'rue des roses','Montpellier','France', 1200.48);


CREATE TABLE `products` (
  `ID` int(11) NOT NULL auto_increment,
  `NAME` varchar(50) NOT NULL default '',
  `PRICE` double NOT NULL default '0',
  `AMOUNT` int(11) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=InnoDB AUTO_INCREMENT=29 ;


INSERT INTO `products` VALUES (1, 'Foo', 3.6, 100);
INSERT INTO `products` VALUES (2, 'Bar', 6.84, 100);
INSERT INTO `products` VALUES (4, 'Baz', 2.232, 100);
INSERT INTO `products` VALUES (9, 'Shme', 5.256, 100);
INSERT INTO `products` VALUES (12, 'Hukarz', 5.2, 100);
INSERT INTO `products` VALUES (14, 'Qux', 5.256, 100);
INSERT INTO `products` VALUES (20, 'Xyzzy', 5.256, 100);
INSERT INTO `products` VALUES (21, 'Gazonc', 46.44, 100);
INSERT INTO `products` VALUES (22, 'Schmurz', 173.376, 100);
INSERT INTO `products` VALUES (23, 'Bing', 173.376, 100);
INSERT INTO `products` VALUES (24, 'Ding', 29.376, 100);
INSERT INTO `products` VALUES (26, 'Patati', 2.88, 100);
INSERT INTO `products` VALUES (27, 'Patata', 100, 100);
INSERT INTO `products` VALUES (28, 'Nyoronyoro', 29.34, 100);


CREATE TABLE `orders` (
  `ID` int(11) NOT NULL auto_increment,
  `CUSTOMER_ID` int(11) NOT NULL default '0',
  `ORDER_DATE` timestamp(14) NOT NULL,
  `PRICE_TOTAL` double NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=InnoDB AUTO_INCREMENT=21 ;



INSERT INTO `orders` VALUES (1, 1, '20050921000000', 22);
INSERT INTO `orders` VALUES (5, 1, '20060921000000', 81.752);
INSERT INTO `orders` VALUES (6, 1, '20050921000000', 1206.788);
INSERT INTO `orders` VALUES (7, 1, '20050921000000', 2167.012);
INSERT INTO `orders` VALUES (9, 1, '20050928000000', 1567.2);
INSERT INTO `orders` VALUES (10, 1, '20050928000000', 86.55);
INSERT INTO `orders` VALUES (15, 2, '20051117000000', 120.168);
INSERT INTO `orders` VALUES (17, 2, '20051118000000', 14.04);
INSERT INTO `orders` VALUES (18, 2, '20051205000000', 0);
INSERT INTO `orders` VALUES (19, 2, '20051205000000', 0);
INSERT INTO `orders` VALUES (20, 2, '20051206000000', 0);


CREATE TABLE `order_items` (
  `ID` int(11) NOT NULL auto_increment,
  `ORDER_ID` int(11) NOT NULL default '0',
  `PRODUCT_ID` int(11) NOT NULL default '0',
  `AMOUNT` int(11) NOT NULL default '0',
  `PRICE` double NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=InnoDB AUTO_INCREMENT=64 ;



INSERT INTO `order_items` VALUES (1, 1, 4, 5, 7.75);
INSERT INTO `order_items` VALUES (2, 1, 2, 3, 14.25);
INSERT INTO `order_items` VALUES (9, 5, 21, 3, 139.32);
INSERT INTO `order_items` VALUES (10, 5, 24, 5, 232.2);
INSERT INTO `order_items` VALUES (11, 6, 12, 10, 52);
INSERT INTO `order_items` VALUES (14, 7, 4, 5, 7.75);
INSERT INTO `order_items` VALUES (15, 7, 27, 10, 464.4);
INSERT INTO `order_items` VALUES (16, 7, 2, 3, 14.25);
INSERT INTO `order_items` VALUES (19, 9, 23, 12, 1444.8);
INSERT INTO `order_items` VALUES (20, 9, 24, 6, 122.4);
INSERT INTO `order_items` VALUES (21, 10, 4, 5, 7.75);
INSERT INTO `order_items` VALUES (22, 10, 21, 2, 64.5);
INSERT INTO `order_items` VALUES (23, 10, 2, 3, 14.25);
INSERT INTO `order_items` VALUES (39, 6, 2, 3, 20.52);
INSERT INTO `order_items` VALUES (43, 15, 2, 8, 54.72);
INSERT INTO `order_items` VALUES (47, 15, 14, 8, 42.048);
INSERT INTO `order_items` VALUES (48, 15, 2, 1, 6.84);
INSERT INTO `order_items` VALUES (55, 17, 2, 0, 0);
INSERT INTO `order_items` VALUES (56, 5, 24, 2, 0);
INSERT INTO `order_items` VALUES (57, 20, 4, 2, 0);
INSERT INTO `order_items` VALUES (58, 6, 14, 10, 52.56);
INSERT INTO `order_items` VALUES (59, 6, 24, 1, 29.376);
INSERT INTO `order_items` VALUES (60, 15, 26, 1, 0);
INSERT INTO `order_items` VALUES (61, 15, 2, 2, 0);
INSERT INTO `order_items` VALUES (62, 6, 26, 5, 12);







