package app;

import generic.BaseObject;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class Customer extends BaseObject implements Serializable {

	private static final long serialVersionUID = 6059066486620628534L;

	private Integer id;

	private String name;

	private String forName;

	private String address;

	private String town;

	private String country;

	private double totalPrice;

	private Set orders = new HashSet();

	public void addOrder(Order order) {
		orders.add(order);
		order.setCustomer(this);
	}
	
	public void removeOrder(Order order) {
		order.setCustomer(null);
		orders.remove(order);
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public String getCountry() {
		return country;
	}

	public void setCountry(String country) {
		this.country = country;
	}

	public String getForName() {
		return forName;
	}

	public void setForName(String forName) {
		this.forName = forName;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Set getOrders() {
		return orders;
	}
	
	public void setOrders(Set orders) {
		this.orders = orders;
	}

	public double getTotalPrice() {
		return totalPrice;
	}

	public void setTotalPrice(double totalPrice) {
		this.totalPrice = totalPrice;
	}

	public String getTown() {
		return town;
	}

	public void setTown(String town) {
		this.town = town;
	}

	public String asString() {
		return id + " " + name + " " + forName + " " + address + " " + town
				+ " " + country + " " + totalPrice;
	}

	public String toString() {
		String result = "[Customer] " + id + " " + name + " " + forName + " "
				+ address + " " + town + " " + country + " " + totalPrice;
		Iterator i = orders.iterator();
		String orders = "Customer orders:\n";
		while (i.hasNext()) {
			Order item = (Order) i.next();
			orders = orders + "  " + item + "\n";
		}
		return result + "\n"+ orders;
	}

}
