package app;

import generic.BaseObject;

import java.io.Serializable;

//import pojo.BaseObject;

/**
 * @author Pfister
 */
public class Product extends BaseObject implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 3945419754145818698L;
	private Integer id;
	private String name;
	private double price;
	private int amount;

	// ===============

	/**
	 * @return Returns the amount.
	 * @uml.property name="amount"
	 */
	public int getAmount() {
		return amount;
	}

	/**
	 * @return Returns the id.
	 * @uml.property name="id"
	 */
	public Integer getId() {
		return id;
	}

	/**
	 * @return Returns the name.
	 * @uml.property name="name"
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return Returns the price.
	 * @uml.property name="price"
	 */
	public double getPrice() {
		return price;
	}

	/**
	 * @param amount
	 *            The amount to set.
	 * @uml.property name="amount"
	 */
	public void setAmount(int i) {
		amount = i;
	}

	/**
	 * @param id
	 *            The id to set.
	 * @uml.property name="id"
	 */
	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * @param name
	 *            The name to set.
	 * @uml.property name="name"
	 */
	public void setName(String string) {
		name = string;
	}

	/**
	 * @param price
	 *            The price to set.
	 * @uml.property name="price"
	 */
	public void setPrice(double d) {
		price = d;
	}

	public String toString() {
		return "[Product] (" + id + ")" + name + " price=" + price + " amount="
				+ amount;
	}
	
	public String asString() {
		return name+" "+price;
	}	
	
}
