package app.dao.jdbc;

import generic.BaseDao;
import generic.BaseObject;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import app.Customer;
import app.Order;

public class CustomerDao implements BaseDao {

	private static final Log log = LogFactory.getLog(CustomerDao.class);

	private static MyStoreDatabase database;

	private static CustomerDao instance;

	private CustomerDao() {

	}

	public static synchronized CustomerDao getInstance() {
		if (instance == null) {
			try {
				database = MyStoreDatabase.getInstance();
				instance = new CustomerDao();
			} catch (Exception e) {
				e.printStackTrace();
				throw new RuntimeException(e);
			}
		}
		return instance;
	}

	public void save(BaseObject instance) {
		save((Customer) instance);
	}

	public void save(Customer instance) { // faire l'opration pour les
											// orders
		try {
			int id = -1;
			String request = "";
			if (instance.getId()!=null)
			   id = instance.getId().intValue();
			Customer exists = findById(new Integer(id));
			if (exists == null)
				request = "insert into customers values (null, " + "'"+
				instance.getName() + "','" +
				instance.getForName() + "','" +
				instance.getAddress() + "','" +
				instance.getTown() + "','" +
				instance.getCountry() + "'," +
				instance.getTotalPrice()+ ")";
			else
			   request = "update customers set NAME ='" +instance.getName()+"',"+
			   "FOR_NAME='"+instance.getForName()+"',"+
			   "ADDRESS='"+instance.getAddress()+"',"+
			   "FOR_NAME='"+instance.getForName()+"',"+
			   "TOWN='"+instance.getTown()+"',"+
			   "COUNTRY='"+instance.getCountry()+"',"+
			   "TOTAL_PRICE="+instance.getTotalPrice()+
			   " where ID="+ id;
			log.debug(request);
			Connection c = database.getConnection();
			if (exists == null) {
				int generatedKey = database.insert(c, request);
				instance.setId(new Integer(generatedKey));
			} else
				database.update(c, request);
			c.close();
		} catch (Exception re) {
			log.error("attach failed", re);
			throw new RuntimeException(re);
		}
	}

	private Customer getInstance(ResultSet rs) throws NumberFormatException,
			SQLException {
		Customer customer = new Customer();
		customer.setId(new Integer(rs.getString("ID")));
		customer.setAddress(rs.getString("ADDRESS"));
		customer.setCountry(rs.getString("COUNTRY"));
		customer.setForName(rs.getString("FOR_NAME"));
		customer.setName(rs.getString("NAME"));
		customer.setTown(rs.getString("TOWN"));
		customer.setTotalPrice(rs.getDouble("TOTAL_PRICE"));
		List orders = OrderDao.getInstance().findByParent(customer);
		Iterator iterator = orders.iterator();
		while (iterator.hasNext()) {
			Order element = (Order) iterator.next();
			customer.addOrder(element);
		}
		return customer;
	}

	public Customer findById(Integer id) {
		if (id == null)
			return null;
		try {
			String query = "select * from customers where ID=" + id.intValue();
			Customer customer = null;
			Connection c = database.getConnection();
			ResultSet rs = database.executeQuery(c, query);
			if (rs.next())
				customer = getInstance(rs);
			c.close();
			return customer;
		} catch (Exception re) {
			log.error("findById failed", re);
			throw new RuntimeException(re);
		}
	}
	
	
	
	public BaseObject findByName(String name) {
		String fnme = name.substring(name.indexOf(';')+1);
		String nme = name.substring(0,name.indexOf(';'));
		try {
			String query = "select * from customers where NAME='" + nme + "' and FOR_NAME='"+fnme+"'";
			log.debug("finding with sql :"+query);
			Customer customer = null;
			Connection c = database.getConnection();
			ResultSet rs = database.executeQuery(c, query);
			if (rs.next()){
				customer = getInstance(rs);
				log.debug("object is found");
			} else
				log.debug("no object found");
			c.close();
			return customer;
		} catch (Exception re) {
			log.error("findByName failed", re);
			throw new RuntimeException(re);
		}
	}	

	public List findByParentId(String id) {
		String filter = ""; // no parent foreign key
		String query = "select * from customers " + filter + " order by ID";
		log.debug(query);
		List result = new ArrayList();
		try {
			Connection c = database.getConnection();
			ResultSet rs = database.executeQuery(c, query);
			while (rs.next()) {
				Customer customer = getInstance(rs);
				result.add(customer);
			}
			c.close();
		} catch (Exception re) {
			log.error("find by ParentId failed", re);
			throw new RuntimeException(re);
		}
		return result;
	}

	public BaseObject findById(String id) {
		if (id == null || id.equals(""))
			return null;
		try {
			return findById(new Integer(id));
		} catch (Exception re) {
			log.error("findById failed", re);
			throw new RuntimeException(re);
		}
	}

	   public void delete(BaseObject instance) { 
		   deleteById(instance.getId().toString());
	   }
	   
	   public void deleteById(String id) { // tester la rcupration des erreurs
		try {
			Connection c = database.getConnection();
			database.update(c, "delete from customers where ID=" + id);
			c.close();
		} catch (Exception re) {
			log.error("delete failed", re);
			throw new RuntimeException(re);
		}
	   }
	
	
	

}