package app.dao.jdbc;

import generic.JdbcDatabase;

import java.sql.ResultSet;

public class MyStoreDatabase extends JdbcDatabase{
	private static MyStoreDatabase instance;

    /**
     * Singleton access method
     * @return MyStoreDatabase single instance
     * @throws Exception 
     */
	
    public static MyStoreDatabase getInstance() throws Exception {
        if (instance == null) {
            instance = new MyStoreDatabase();
            instance.setDriver("com.mysql.jdbc.Driver");
            instance.setServer("jdbc:mysql://localhost:3306/");
            instance.setDatabase("mystore2");
            instance.setUser("root"); 
            instance.setPw("");
            instance.openTestConnection();
			try {
				instance.getSampleResultSet().next();
			} catch (Exception e) {
				e.printStackTrace();
				throw(e);
			} finally {
				instance.closeConnection();
			}
        }
        return instance;
    }	
    
	
	protected String getSampleRequestString() {
		return "select * from orders";
	}    
    
	public static void main(String[] args) {
		try {
			MyStoreDatabase cnx = getInstance();
			cnx.openTestConnection();
			ResultSet rs = cnx.getSampleResultSet();
			while (rs.next()) {
				String id = rs.getString("ID");
				String date = rs.getString("ORDER_DATE");
				System.out.println("ROW = " + id + " " + date);
			}
			cnx.closeConnection();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}




}
