package app.dao.jdbc;

import generic.BaseDao;
import generic.BaseObject;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import utils.DateUtils;
import app.Customer;
import app.Order;
import app.OrderItem;

public class OrderDao implements BaseDao {

	private static final Log log = LogFactory.getLog(OrderDao.class);

	private static MyStoreDatabase database;

	private static OrderDao instance;

	private OrderDao() {

	}

	public static synchronized OrderDao getInstance() {
		if (instance == null) {
			try {
				database = MyStoreDatabase.getInstance();
				instance = new OrderDao();
			} catch (Exception e) {
				e.printStackTrace();
				throw new RuntimeException(e);
			}
		}
		return instance;
	}

	// todo: grer la suppression des items, et cls des customers
	public void save(Order instance) { // faire l'opration pour les orderitems
		try {
			int id = -1;
			String request = "";
			if (instance.getId() != null)
				id = instance.getId().intValue();
			Order exists = (Order) findById(new Integer(id).toString());
			if (exists == null) {
				int customerId = instance.getCustomer().getId().intValue();
				request = "insert into orders values (null, " + customerId
						+ ",'" + DateUtils.getYmdDate(instance.getDate())
						+ "', " + instance.getPriceTotal() + ")";
			}else
				request = "update orders set ORDER_DATE ='"
						+ DateUtils.getYmdDate(instance.getDate())
						+ "', PRICE_TOTAL =" + instance.getPriceTotal()
						+ " where ID=" + id;
			log.debug(request);
			Connection c = database.getConnection();
			if (exists == null) {
				int generatedKey = database.insert(c, request);
				instance.setId(new Integer(generatedKey));
			} else
				database.update(c, request);
			c.close();
		} catch (Exception re) {
			log.error("attach failed", re);
			throw new RuntimeException(re);
		}
	}

	public void save(BaseObject instance) {
		save((Order) instance);
	}

	public void delete(BaseObject instance) {
		deleteById(instance.getId().toString());
	}

	private Order getInstance(ResultSet rs) throws NumberFormatException,
			SQLException {
		Order order = new Order();
		order.setId(new Integer(rs.getString("ID")));
		order.setDate(DateUtils.mySqlStringToDate(rs.getString("ORDER_DATE"))); 																																// yyyyMMddHHMMSS
		//Customer customer = (Customer) CustomerDao.getInstance().findById(new Integer(rs.getString("CUSTOMER_ID")));
		//order.setCustomer(customer);
		List orderItems = OrderItemDao.getInstance().findByParent(order);
		Iterator iterator = orderItems.iterator();
		while (iterator.hasNext()) {
			OrderItem element = (OrderItem) iterator.next();
			order.addOrderItem(element);
		}
		order.setPriceTotal(rs.getDouble("PRICE_TOTAL"));
		// plutt calculer le prix ici ??
		// pourrait-devrait tre un champ calcul ??
		// c'est le bean mtier qui doit le faire, pas de rgles de gestion ici
		return order;
	}

	public Order findById(Integer id) {
		if (id == null)
			return null;
		try {
			String query = "select * from orders where ID=" + id.intValue();
			Order order = null;
			Connection c = database.getConnection();
			ResultSet rs = database.executeQuery(c, query);
			if (rs.next()){
				order = getInstance(rs);
				//Customer customer = (Customer) CustomerDao.getInstance().
				//findById(order.getCustomer().getId());	
			}
			c.close();
			return order;
		} catch (Exception re) {
			log.error("findById failed", re);
			throw new RuntimeException(re);
		}
	}

	public List findByParent(Customer customer) {
		String filter = " where CUSTOMER_ID=" + customer.getId();
		// no parent foreign key
		String query = "select * from orders " + filter + " order by ID";
		log.debug(query);
		List result = new ArrayList();
		try {
			Connection c = database.getConnection();
			ResultSet rs = database.executeQuery(c, query);
			while (rs.next()) {
				Order order = getInstance(rs);
				order.setCustomer(customer);
				result.add(order);
			}
			c.close();
		} catch (Exception re) {
			log.error("find by ParentId failed", re);
			throw new RuntimeException(re);
		}
		return result;
	}

	public List findByParentId(String id) {
		if (id != null && id.length() > 0) {
			Customer customer = (Customer) CustomerDao.getInstance().findById(
					id);
			return findByParent(customer);
		} else
			return null;
	}

	public BaseObject findById(String id) {
		if (id == null)
			return null;
		try {
			return findById(new Integer(id));
		} catch (Exception re) {
			log.error("findById failed", re);
			throw new RuntimeException(re);
		}
	}

	public void deleteById(String id) { // tester la rcupration des erreurs
		try {
			Connection c = database.getConnection();
			database.update(c, "delete from orders where ID=" + id);
			c.close();
		} catch (Exception re) {
			log.error("delete failed", re);
			throw new RuntimeException(re);
		}
	}

}