package app.dao.jdbc;

import generic.BaseDao;
import generic.BaseObject;
import generic.PersistenceException;

import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import utils.DateUtils;



import app.Product;

public class ProductDao implements BaseDao {

	private static final Log log = LogFactory.getLog(ProductDao.class);

	private static MyStoreDatabase database;

	private static ProductDao instance;

	private ProductDao() {

	}

	public static synchronized ProductDao getInstance() {
		if (instance == null)
			try {
				database = MyStoreDatabase.getInstance();
				instance = new ProductDao();
			} catch (Exception e) {
				e.printStackTrace();
			}
		return instance;
	}

	public void save(Product instance) {
		try {
			int id = -1;
			String request = "";
			if (instance.getId() != null)
				id = instance.getId().intValue();
			Product exists = findById(new Integer(id));
			if (exists == null)
				request = "insert into products values (null, " + "'"
						+ instance.getName() 
						+ "'," + instance.getPrice()
						+ "," + instance.getAmount()
					    + ")";
			else
				request = "update products set NAME ='" + instance.getName()
						+ "'," + "PRICE=" + instance.getPrice() + ","
						+ "AMOUNT=" + instance.getAmount() 
						+ " where ID=" + id;
			log.debug(request);
			Connection c = database.getConnection();
			if (exists == null) {
				int generatedKey = database.insert(c, request);
				instance.setId(new Integer(generatedKey));
			} else
				database.update(c, request);
			c.close();
		} catch (Exception re) {
			log.error("attach failed", re);
			throw new RuntimeException(re);
		}
	}


	public void save(BaseObject instance) {
		save((Product) instance);
	}

	public Product findById(Integer id) {
		String filter = "where ID=" + id.toString();
		String query = "SELECT ID, NAME, PRICE, AMOUNT FROM products " + filter;

		try {
			Connection c = database.getConnection();
			ResultSet rs = database.executeQuery(c, query);
			Product product = null;
			if (rs.next()){
			  product = new Product();
			  product.setId(new Integer(rs.getString("ID")));
			  product.setAmount(rs.getInt("AMOUNT"));
			  product.setName(rs.getString("NAME"));
			  product.setPrice(rs.getDouble("PRICE"));
			}
			c.close();
			return product;
			// version orm
			// String query = "from app.product " + filter;
			// Query q =
			// SessionManager.getInstance().getCurrentSession().createQuery(query);
			// result = q.list();
		} catch (Exception re) {
			log.error("find by Id failed", re);
			return null;
		}
	}

	public BaseObject findById(String id) {
		if (id == null)
			return null;
		try {
			return findById(new Integer(id));
		} catch (Exception re) {
			log.error("find By Id failed", re);
			return null;
		}
	}

	public List findByParentId(String id) {
		String filter = "";
		String query = "SELECT ID, NAME, PRICE, AMOUNT FROM products " + filter
				+ " order by ID";
		log.debug(query);
		List result = new ArrayList();
		try {
			Connection c = database.getConnection();
			ResultSet rs = database.executeQuery(c, query);
			while (rs.next()) {
				Product product = new Product();
				product.setId(new Integer(rs.getString("ID")));
				product.setAmount(rs.getInt("AMOUNT"));
				product.setName(rs.getString("NAME"));
				product.setPrice(rs.getDouble("PRICE"));
				result.add(product);
			}
			c.close();
			// version orm
			// String query = "from app.product " + filter;
			// Query q =
			// SessionManager.getInstance().getCurrentSession().createQuery(query);
			// result = q.list();
		} catch (Exception re) {
			log.error("find by ParentId failed", re);
			return null;
		}
		return result;
	}

	   public void delete(BaseObject instance) { 
		   deleteById(instance.getId().toString());
	   }
	   
	   public void deleteById(String id) { // tester la rcupration des erreurs
		try {
			Connection c = database.getConnection();
			database.update(c, "delete from products where ID=" + id);
			c.close();
		} catch (Exception re) {
			log.error("delete failed", re);
			throw new RuntimeException(re);
		}
	   }
	

}