package generic;

import java.util.Comparator;

import utils.BeanUtils;

public abstract class BaseObject implements Comparable{
	
	public static final Comparator ID_ORDER  = new Comparator( ) {
		public int compare(Object o1, Object o2) {
			BaseObject bo1 = (BaseObject)o1;
			BaseObject bo2 = (BaseObject)o2;
			return bo1.getId( ).compareTo(bo2. getId( ));
		}
	};
	
	public abstract Integer getId();

	public abstract String asString();

	public String getProperty(String attribute) {
		return BeanUtils.getPropertyAsString(this, attribute);
	}
	
	public int compareTo(Object obj) {
		BaseObject e  = (BaseObject)obj;
		return getId().compareTo(e.getId( ));
	}		
	
	public boolean equals(Object o){
		if (o instanceof BaseObject)
		  return (((BaseObject)o).getId()).equals(getId());
		else
		  return false;	
	}
	
	public int hashCode(){
		Integer id = getId();
		if (id == null)
			id = new Integer(0);
		return id.toString().hashCode();
	}
		
}
