/*
 * JdbcDatabase.java
 *
 * 
 */
package generic;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

// import menu.MenuItem;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * 
 * 
 * @author fpfister
 */
public abstract class JdbcDatabase {

	private static Log log = LogFactory.getLog(JdbcDatabase.class);
	private Connection testConnection = null;
	private String driver = "com.mysql.jdbc.Driver";
	private String server = "jdbc:mysql://localhost:3306/";
	private String database = "foo";
	private String user = "bar";
	private String pw = "bouze";
	private static JdbcDatabase instance;

	protected ArrayList items = new ArrayList();

	public Connection getConnection() throws Exception {
		try {
			Class.forName(driver).newInstance();
			Connection connection = DriverManager.getConnection(server + database, user, pw);
			return connection;
		} catch (Exception e) {
			log.error("unable to open connection");
			throw new Exception(e.getMessage());
		}
	}

	protected void openTestConnection() throws Exception {
		try {
			Class.forName(driver).newInstance();
			testConnection = DriverManager.getConnection(server + database, user, pw);
		} catch (Exception e) {
			log.error("unable to open connection");
			throw new Exception(e.getMessage());
		}
	}

	protected ResultSet getSampleResultSet() throws Exception {
		ResultSet rs = null;
		String request = getSampleRequestString();
		openTestConnection();
		try {
			Statement st = testConnection.createStatement();
			rs = st.executeQuery(request);
		} catch (SQLException e) {
			log.error("unable to get data");
			throw new Exception(e.getMessage());
		}
		return rs;
	}

	public ResultSet executeQuery(Connection connection, String request) throws Exception {
		ResultSet rs = null;
		try {
			Statement st = connection.createStatement();
			rs = st.executeQuery(request);
		} catch (SQLException e) {
			log.error("unable to get data");
			throw new Exception(e.getMessage());
		}
		return rs;
	}

	public void update(Connection connection, String request) throws Exception {
		try {
			Statement st = connection.createStatement();
			st.executeUpdate(request);
		} catch (SQLException e) {
			log.error("unable to update data");
			throw new Exception(e.getMessage());
		}
	}

	public int insert(Connection connection, String request) throws Exception {
		int key = -1;
		try {
			Statement st = connection.createStatement();
			st.executeUpdate(request, Statement.RETURN_GENERATED_KEYS);
			ResultSet k = st.getGeneratedKeys();
			if (k.next())
				key = k.getInt(1);
			return key;
		} catch (SQLException e) {
			log.error("unable to update data");
			throw new Exception(e.getMessage());
		}
	}

	protected void closeConnection() {
		try {
			if (testConnection != null && !testConnection.isClosed()) {
				testConnection.close();
			}
		} catch (Exception e) {

		}
	}

	protected void createTable() {
		String request = "DROP TABLE ....\n ";
		try {
			openTestConnection();
			Statement st = testConnection.createStatement();
			ResultSet rs = st.executeQuery(request);
		} catch (Exception e) {

		}
	}

	protected boolean insertRows() {
		String request = "INSERT INTO ....";

		try {
			openTestConnection();
			Statement st = testConnection.createStatement();
			st.executeQuery(request);
		} catch (Exception e) {
			return false;
		}
		return true;
	}

	public JdbcDatabase() {
		super();
	}

	protected abstract String getSampleRequestString();

	public void setDatabase(String database) {
		this.database = database;
	}

	public void setDriver(String driver) {
		this.driver = driver;
	}

	public void setPw(String pw) {
		this.pw = pw;
	}

	public void setServer(String server) {
		this.server = server;
	}

	public void setUser(String user) {
		this.user = user;
	}

}
