package utils;

import generic.BaseObject;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;



public class HtmlUtils {

	private static Log log = LogFactory.getLog(HtmlUtils.class);

	
	protected static String lowerFirst(String s) {
		return s.substring(0, 1).toLowerCase() + s.substring(1);
	}

	/*
	 * @usage makeSelect(session,orderItem,"Product");
	 */

	public static String makeSelect(HttpServletRequest request, BaseObject parent,
			BaseObject object, String cn) {
		if (object != null) {
			String className = object.getClass().getName();
			className = className.substring(className.lastIndexOf(".") + 1); // remove qualifier
			int cglibenh = className.indexOf("$$EnhancerByCGLIB"); //remove that
			if (cglibenh > -1)
				className = className.substring(0, cglibenh);
			List objz = null;
			if (parent != null) {
				String attr = className + "s";
				objz = (List) request.getAttribute(attr);
				return makeSelect(objz, lowerFirst(className) + ".id", object
						.getId());
			}
			return "error";
		} else{
			String className = cn;
			List objz = null;
			if (parent != null) {
				String attr = className + "s";
				objz = (List) request.getAttribute(attr);
				return makeSelect(objz, lowerFirst(className) + ".id", null);
			}
			return "error";
		}

	}

	public static String makeSelect(List objz, String name, Integer id) {
		String result = "\n<select name=\"" + name + "\">";
		if (objz == null)
			result += "\n<option value=\"-1\">error</option>";
		else if (id == null || (id !=null && id.intValue() == -1))
			result += "\n<option value=\"-1\">aucun</option>";
		if (objz == null)
			return result;
		Iterator lli = objz.iterator();
		while (lli.hasNext()) {
			BaseObject p = (BaseObject) lli.next();
			Integer pid = p.getId();
			result += "\n<option ";
			if (pid.equals(id))
				result += "selected ";
			result += "value=\"" + p.getId() + "\">" + p.asString()
					+ "</option>";
		}
		result += "\n</select>";
		return result;
	}
	
}
