import generic.PersistenceException;

import java.util.Iterator;
import java.util.List;

import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import app.Customer;
import app.dao.jdbc.CustomerDao;

public class CustomerTest extends TestCase{

	private static Log log = LogFactory.getLog(CustomerTest.class);

	private String name;

	private String forName;

	private String address;

	private String town;

	private String country;

	private String totalPrice;

	private Customer customer;

	private static CustomerDao customerDao = CustomerDao.getInstance();

	protected void link() {
	}

	protected void update() {
		customer.setAddress(address);
		customer.setCountry(country);
		customer.setForName(forName);
		customer.setName(name);
		customer.setTotalPrice(Double.parseDouble(totalPrice));
		customer.setTown(town);
	}

	protected List findByParentId(String id) throws PersistenceException {
		return customerDao.findByParentId(id);
	}

	public Customer getCustomer() {
		return customer;
	}

	protected Customer findByName(String name, String forName)
			throws PersistenceException {
		return (Customer) customerDao.findByName(name + ";" + forName);
	}

	protected Customer findById(String id) throws PersistenceException {
		return (Customer) customerDao.findById(id);
	}

	protected void save() {
		customerDao.save(customer);
	}

	protected void delete() {
		log.debug("delete " + name);
		customerDao.delete(customer);
	}

	protected void newObject() {
		customer = new Customer();
	}

	public String toString() {
		String result = "";
		try {
			List customers = findByParentId(null);
			Iterator custIterator = customers.iterator();
			while (custIterator.hasNext()) {
				Customer customer = (Customer) custIterator.next();
				result += customer;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	public void create() throws PersistenceException {
		name = "Toutankhamon";
		forName = "Jean-Paul";
		address = "352, rue des Pyramides";
		town = "Thbes";
		country = "Egypte";
		totalPrice = "10000.99";
		log.debug("create " + name);
		newObject();
		update();
		link();
		save();
		String result = toString();
		String expected = "Toutankhamon Jean-Paul 352, rue des Pyramides Thbes Egypte 10000.99";
		assertTrue(result.indexOf(expected) >=0);
	}

	public Customer find_bad(Integer id) throws PersistenceException {
		log.debug("find " + name);
		Customer o = findById(customer.getId().toString());
		assertNotNull(o);
		return o;
	}
	
	public Customer find(Integer id) throws PersistenceException {
		log.debug("find " + id);
		Customer o = findById(id.toString());
		assertNotNull(o);
		return o;
	}

	public void testCreateDelete() {
		try {
			OrderTest orderTest = new OrderTest();
			OrderItemTest orderItemTest = new OrderItemTest();
			create();
			find(customer.getId());
			orderTest.createWithParent(getCustomer());
			orderItemTest.createAllWithParent(orderTest.getOrders());
			log.info(getCustomer());
			orderItemTest.deleteAll(orderTest.getOrders());
			orderTest.deleteAll();
			delete();
			
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	
	public void testFindUpdate() {
		try {
			customer = find(new Integer(2));
			customer.setName("Machin");
			save();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}


}
