import generic.PersistenceException;

import java.util.Iterator;
import java.util.List;

import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import app.Product;
import app.dao.jdbc.ProductDao;

public class ProductTest extends TestCase{

	private static Log log = LogFactory.getLog(ProductTest.class);

	private String name;
    private String amount;
	private String price;
	
	private Product product;

	private static ProductDao productDao = ProductDao.getInstance();

	protected void link() {
	}

	protected void update() {
		product.setAmount(Integer.parseInt(amount));
		product.setName(name);
		product.setPrice(Double.parseDouble(price));
	}

	protected List findByParentId(String id) throws PersistenceException {
		return productDao.findByParentId(id);
	}

	public Product getProduct() {
		return product;
	}


	protected Product findById(String id) throws PersistenceException {
		return (Product) productDao.findById(id);
	}

	protected void save() {
		productDao.save(product);
	}

	protected void delete() {
		log.debug("delete " + name);
		productDao.delete(product);
	}

	protected void newObject() {
		product = new Product();
	}

	public String toString() {
		String result = "";
		try {
			List products = findByParentId(null);
			Iterator custIterator = products.iterator();
			while (custIterator.hasNext()) {
				Product product = (Product) custIterator.next();
				result += product;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return result;
	}

	public void create() throws PersistenceException {
		name = "chihuahua";
		amount= "100";
		price = "10.99";
		log.debug("create " + name);
		newObject();
		update();
		link();
		save();
		String result = toString();
		String expected = "chihuahua price=10.99 amount=100";
		assertTrue(result.indexOf(expected) >=0);
	}

	public Product find_bad(Integer id) throws PersistenceException {
		log.debug("find " + name);
		Product o = findById(product.getId().toString());
		assertNotNull(o);
		return o;
	}
	
	public Product find(Integer id) throws PersistenceException {
		log.debug("find " + id);
		Product o = findById(id.toString());
		assertNotNull(o);
		return o;
	}

	public void testCreateDelete() {
		try {
			create();
			find(product.getId());
			log.info(getProduct());
			delete();			
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

	
	public void testFindUpdate() {
		try {
			product = find(new Integer(2));
			product.setName("Bidule");
			save();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}


}
