package servlet;

import generic.BaseObject;
import generic.PersistenceException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import app.Customer;
import app.dao.jdbc.CustomerDao;

public class TestCustomerServlet extends BaseServlet {

	private static final long serialVersionUID = 6731281431244223426L;

	private static Log log = LogFactory.getLog(TestCustomerServlet.class);

	private Customer customer;

	private String name;
	private String forName;
	private String address;
	private String town;
	private String country;
	private String totalPrice;

	public void init(ServletConfig arg0) throws ServletException {
		beanName = "customer";
		listName = "customers";
		forward = "jsp/testcustomer.jsp";
		dao = CustomerDao.getInstance();
		super.init(arg0);
	}

	protected BaseObject getBean() {
		return customer;
	}

	protected void setBean(BaseObject bean) {
		customer = (Customer) bean;
	}

	protected Customer findByName(String name, String forName)
			throws PersistenceException {
		log.debug("findByName " + name + ";" + forName);
		return (Customer) ((CustomerDao) dao).findByName(name + ";" + forName);
	}

	protected void newBean() {
		customer = new Customer();
	}

	protected void update() {
		customer.setAddress(address);
		customer.setCountry(country);
		customer.setForName(forName);
		customer.setName(name);
		try {
			customer.setTotalPrice(Double.parseDouble(totalPrice));
		} catch (Exception e) {

		}
		customer.setTown(town);
	}

	protected void getParameters(HttpServletRequest request) {
		address = request.getParameter("address");
		country = request.getParameter("country");
		forName = request.getParameter("forName");
		name = request.getParameter("name");
		totalPrice = request.getParameter("totalPrice");
		town = request.getParameter("town");
	}

	protected void clear() {
		address = "";
		country = "";
		forName = "";
		name = "";
		totalPrice = "0.0";
		town = "";
	}

	protected void setParentBean(BaseObject parent) {
		// no parent bean
	}

	protected void link() {
		// no parent bean
	}

	protected void unlink() {
		// no parent bean
	}

}
