package servlet;

import generic.BaseObject;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import app.Order;
import app.OrderItem;
import app.Product;
import app.dao.jdbc.OrderDao;
import app.dao.jdbc.OrderItemDao;
import app.dao.jdbc.ProductDao;

public class TestOrderItemServlet extends BaseServlet {

	private static Log log = LogFactory.getLog(TestOrderItemServlet.class);

	private ProductDao productDao;
	private Order order;
	private OrderItem currentOrderItem;
	private Product product;
	private String productId;
	private String amount;
	private String price;

	public void init(ServletConfig arg0) throws ServletException {
		beanName = "orderitem";
		listName = "orderitems";
		forward = "jsp/testorderitem.jsp";
		dao = OrderItemDao.getInstance();
		parentDao = OrderDao.getInstance();
		productDao = ProductDao.getInstance();
		super.init(arg0);
	}

	protected void setParentBean(BaseObject parent) {
		order = (Order) parent;
	}

	protected void update() {
		boolean insertion = false;
		currentOrderItem.setProductAmount(product, Integer.parseInt(amount),
				insertion);
	}

	protected void link() {
		order.addOrderItem(currentOrderItem);
		currentOrderItem.setOrder(order);
	}

	protected void unlink() {
		order.removeOrderItem(currentOrderItem);
	}

	protected void getParameters(HttpServletRequest request) {
		productId =(String) request.getParameter("product.id");
		amount = (String) request.getParameter("amount");
		price = (String) request.getParameter("price");
	}

	protected void clear() {
		productId = "";
		product = null;
		amount = "0";
		price = "0.0";
	}



	protected BaseObject getBean() {
		return currentOrderItem;
	}

	protected void beforeDispatch(HttpServletRequest request,
			HttpServletResponse response){
		request.setAttribute("product", product);
		//ici obtenir la listes de rfrence pour la boite select
	}	
	
	protected void setReferences() {
		product = currentOrderItem.getProduct();
		if (productId != null && "modifier".equals(cmd) || "ajouter".equals(cmd)){
			product = (Product) productDao.findById(productId);
			currentOrderItem.setProduct(product);
		}
	}	
	
	protected void newBean() {
		currentOrderItem = new OrderItem();
	}	
	
	protected void setBean(BaseObject bean) {
		currentOrderItem = (OrderItem) bean;
	}

}
