package servlet;

import generic.BaseObject;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import utils.DateUtils;
import app.Customer;
import app.Order;
import app.dao.jdbc.CustomerDao;
import app.dao.jdbc.OrderDao;


public class TestOrderServlet extends BaseServlet {

	private static Log log = LogFactory.getLog(TestOrderServlet.class);

	private Order currentOrder;
	private Customer customer;
	
	private String date;
	private String priceTotal;	
	
	public void init(ServletConfig arg0) throws ServletException {
		beanName = "order";
		listName = "orders";
		forward = "jsp/testorder.jsp";
		dao = OrderDao.getInstance();
		parentDao = CustomerDao.getInstance();
		super.init(arg0);
	}

	protected BaseObject getBean() {
		return currentOrder;
	}
	
	protected void setBean(BaseObject bean) {
		currentOrder = (Order)bean;
	}
	
	protected void newBean() {
		currentOrder = new Order();
	}

	protected void update() {
		currentOrder.setDate(DateUtils.stringDMY2Date(date));
		try {
			currentOrder.setPriceTotal(Double.parseDouble(priceTotal));
		} catch (Exception e) {

		}
	}
	
	protected void link() {
		currentOrder.setCustomer(customer);
		customer.addOrder(currentOrder);
	}	
	
	protected void unlink() {
		customer.removeOrder(currentOrder);
	}
	

	protected void getParameters(HttpServletRequest request) {
		date = request.getParameter("date");
		priceTotal = request.getParameter("priceTotal");
	}

	protected void clear() {
		date = "01/01/2000"; //a voir
		priceTotal = "0.0";
	}
	
	protected void setParentBean(BaseObject parent){
		customer = (Customer)parent;
	}
			
	

}
